//
//  BPlusTreeNode.hpp
//  B+Tree
//
//  Created by 葉朝鈞 on 2021/3/30.
//  Copyright © 2021 葉朝鈞. All rights reserved.
//

#ifndef BPlusTreeNode_hpp
#define BPlusTreeNode_hpp

#include <stdio.h>

class BPlusTreeNode {
private:
    int a, n; // (a << 1) 阶 B+ 树
    int *keys;
    BPlusTreeNode **childs;
    bool leaf;
    BPlusTreeNode *prev, *next;
public:
    BPlusTreeNode(int a, bool leaf);
    BPlusTreeNode *lookup(int k);
    int maxKey();
    int minKey();
    void traverse();
    void insert(int k);
    int findKey(int k);
    void splitChild(int i, BPlusTreeNode* y);
    void remove(int k);
    void mergeToLeft(int p);
    void borrowFromLeft(int p);
    void borrowFromRight(int p);

    friend class BPlusTree; // so that BTree can visit privated items of BTreeNode
};

#endif /* BPlusTreeNode_hpp */
