//
//  BTreeNode.hpp
//  BTree
//
//  Created by 葉朝鈞 on 2019/2/16.
//  Copyright © 2019 TalentEndless. All rights reserved.
//

#ifndef BTreeNode_hpp
#define BTreeNode_hpp

class BTreeNode {
private:
    int a, n; // (a << 1) 阶 B 树
    int *keys;
    BTreeNode **childs;
    bool leaf;
public:
    BTreeNode(int a, bool leaf);
    BTreeNode *lookup(int k);
    int maxKey();
    int minKey();
    int traverse();
    void insert(int k);
    int findKey(int k);
    void splitChild(int i, BTreeNode* y);
    void remove(int k);
    void removeFromLeaf(int p);
    void removeFromNonLeaf(int p);
    void mergeToLeft(int p);
    void borrowFromLeft(int p);
    void borrowFromRight(int p);

    friend class BTree; // so that BTree can visit privated items of BTreeNode
};

#endif /* BTreeNode_hpp */
